<?php

namespace App\Helper;

use Symfony\Component\HttpFoundation\Response;

class ApiResponserHelper
{
   public static function successResponse($status, $data, $message, $code = Response::HTTP_OK)
    {
        return response()->json([
            'success' => $status,
            'message' => $message,
            'data' => $data
        ], $code);
    }

    public static function failedResponse($error, $code)
    {
        return response()->json([
            'status' => 'Error',
            'message' => $error,
        ], $code);
    }
    function onSuccess($data, $code = 200)
    {
        return response()->json([
            'success' => true,
            'data' => $data
        ], $code);
    }

    function onFaile($message, $code = 200)
    {
        return response()->json([
            'success' => false,
            'message' => $message
        ], $code);
    }



}
