<?php

namespace App\Http\Controllers\Admin\Services;

use App\QueryFilters\StatusFilter;
use App\Services\ChatService;
use Illuminate\Pipeline\Pipeline;
use Mojtaba\Chatable\Models\Group;
use Mojtaba\Chatable\Models\Member;

class GroupChatService
{
    public function index()
    {
        $groups=\app(Pipeline::class)
            ->send(Group::query())
            ->through(
                StatusFilter::class
            )
            ->thenReturn()
            ->orderBy('created_at','desc')
            ->paginate(30);

        return successResponse(true,['groups'=>$groups]);
    }

    public function addMember($request)
    {
        $chatService=new ChatService();
        return successResponse(true,['members'=>$chatService->addMemberUser($request)]);
    }

    public function deleteMember($groupId,$memberId)
    {
        $member=Member::query()->where('group_id',$groupId)->where('member_id',$memberId)->first();
        if ($member){
            $member->delete();
            return successResponse(true,[]);
        }
        else{
            return  failedResponse('member not found');
        }
    }

    public function delete($groupId)
    {
        $group=Group::query()->where('id',$groupId)->first();
        if ($group){
            $group->delete();
            return successResponse(true,[]);
        }
        else{
            return  failedResponse('group not found');
        }
    }

}