<?php

namespace App\Http\Controllers\Admin\Services;

use App\Models\Admin\Role;

class RoleService
{
    public function index()
    {
        $roles=Role::with('permissions')->paginate(20);
        return $roles;
    }
    public function create($request)
    {
        $role=new Role();
        $role->name=$request->name;
        $role->content=$request->content;
        $role->save();
        $role->permissions()->sync($request->permissions);
        return true;


    }

    public function update($request,$roleId)
    {
//        return $request->name;
        $role=Role::query()->where('id',$roleId)->first();
//        return $role;
        if ($role){
            $check_name=Role::query()
                ->where('name',$request->name)
                ->where('id','!=',$roleId)
                ->first();
           if (!$check_name){
               $role->name=$request->name !== null ? $request->name : $role['name'];
               $role->content=$request->content !== null ? $request->content : $role['content'];
               $role->save();
//               return $role;
               if (count($request->permissions) > 0){
                   $role->permissions()->toggle($request->permissions);
               }
               return ['success'=>true,'data'=>['role'=>$role]];

           }
           else{
               return ['success'=>false,'message'=>'The entered name is duplicate'];
           }
        }
        else{
            return ['success'=>false,'message'=>'The role could not be found'];
        }
    }

    public function show($roleId)
    {
        $role=Role::with('permissions')->where('id',$roleId)->first();
        if ($role){
            return $role;
        }
        else{
            return false;
        }
    }

    public function delete($roleId)
    {
        $role=Role::query()->where('id',$roleId)->first();
        if ($role){
            $role->delete();
            return true;
        }
        else{
            return false;
        }
    }
}
