<?php

namespace App\Http\Controllers;

use App\Http\Requests\DetailsGalleryRequests;
use App\Http\Resources\ShowAllGalleryResource;
use App\Http\Resources\ShowDetailsGalleryResource;
use App\Http\Resources\StyleProjectGalleryResource;
use App\Models\Image;
use App\Models\Keyword;
use App\Models\Project;
use App\Models\Report;
use App\Models\Style;
use App\Traits\ApiResponser;
use Illuminate\Http\Request;
use Illuminate\Support\Arr;
use Illuminate\Support\Str;
use Staudenmeir\EloquentEagerLimit\HasEagerLimit;

class GalleryController extends Controller
{
    use ApiResponser,HasEagerLimit;
    public $clientType;
    public $clientEntity;
    public $clientId;
    public $client;
    public function showForUser($clientRole){
        $this->setInformation($clientRole);
//            return $this->clientType;
        $gallery['project']=Project::query()
            ->where('projectable_type',$this->clientType)
            ->where('projectable_id',$this->clientId)
            ->with(['imagesTake'=>function($q){
//            $q->where('imageable_type',Project::class)->take(4);
            $q->take(1);
        }])->get();

      $project_id=  Project::where('projectable_type',$this->clientType)
            ->where('projectable_id',$this->clientId)->pluck('id');
//      return $project_id;
        $gallery['key_word']=Keyword::query()
            ->whereHas('images',function ($q) use($project_id){
            $q->where('imageable_type',Project::class)
                ->whereIn('imageable_id',$project_id);
//                ->whereHas('imageable',function ($q){
//                $q->where('');
//            });
        })->get();
//        return  $gallery['key_word'];

        $gallery['style']=Style::query()->whereHas('projects',function ($q) use($project_id){
            $q      ->where('projectable_type',$this->clientType)
                ->where('projectable_id',$this->clientId);
        })->get();
//                return  $gallery['style'];

        return ($gallery)? $this->onSuccess(new ShowAllGalleryResource(collect($gallery))):$this->onFaile($gallery);
    }
    public function showDetailsForUser(DetailsGalleryRequests $request){
//        return 1;
        $photo=null;
        if ($request->type=='key_word')
       $photo= Keyword::find($request->id);
        if ($request->type=='project')
         $photo= Project::find($request->id);
        if ($request->type=='style') {
            $photo = Project::where('style', $request->id)->get();
            return ($photo)? $this->onSuccess(Arr::flatten(StyleProjectGalleryResource::collection($photo->load('images'))->resolve())):$this->onFaile('photo not found');
        }
        return ($photo)? $this->onSuccess(ShowDetailsGalleryResource::collection($photo->images)):$this->onFaile('photo not found');
    }
    public function setInformation($clientRole)
    {
        $this->clientType = 'App\\Models\\' . Str::ucfirst($clientRole);
        $this->clientEntity = auth($clientRole)->user();
        $this->clientId = $this->clientEntity->id;
        $this->client = $this->clientType::find($this->clientId);
        return 1;
    }

}
