<?php

namespace App\Http\Controllers;

use App\Http\Requests\CreateTagRequest;
use App\Http\Resources\ListTagResource;
use App\Models\Tag;
use App\Notifications\NotificationData;
use App\Notifications\TagNotification;
use App\Traits\ApiResponser;
use App\Traits\Helper;
use http\Client\Curl\User;
use Illuminate\Http\Request;
use Illuminate\Support\Str;
use Mojtaba\Chatable\Models\Group;
use Mojtaba\Chatable\Models\Member;

class TagsController extends Controller
{
    use NotificationData, ApiResponser, Helper;

    public function store($clientRole, CreateTagRequest $request)
    {
//         $this->read($clientRole);
        $client = auth($clientRole)->user();
//        return $client;
        $tag = null;
        if ($client) {
//            return
//            return $request->taggable_type;
//            return       Tag::where('group_id',$request->group_id)
//                ->where('client_id', $client->id)
//                ->where('taggable_id',$request->taggable_id)->
//                where('client_type',get_class($client))->
//                where('taggable_type',$this->getPathClass($request->taggable_type))->
//                first();

//            if (
//                Tag::where('group_id',$request->group_id)
//                ->where('client_id', $client->id)
//                ->where('taggable_id',$request->taggable_id)->
//                where('client_type',get_class($client))->
//                where('taggable_type',$this->getPathClass($request->taggable_type))->
//                first())
//                return $this->onFaile('This request has already been registered');


            $user = ('App\\Models\\' . Str::ucfirst($clientRole))::where('id', $request->taggable_id)->first();
            if ($clientRole == $request->taggable_type && $client->id == $request->taggable_id)
                return $this->onFaile('You can not tag yourself ');
            if (!$user)
                return $this->onFaile('user not found ');
            $clientGroup = Member::where('group_id', $request->group_id)
                ->where('member_type', get_class($client))
                ->where('member_id', $client->id)
                ->first();
            $taggabletGroup = Member::where('group_id', $request->group_id)
                ->where('member_type', 'App\\Models\\' . Str::ucfirst($request->taggable_type))
                ->where('member_id', $request->taggable_id)
                ->first();

            if (!$clientGroup || !$taggabletGroup)
                return $this->onFaile('user must be a member of the group');

            $tag = Tag::create([
                'client_id' => $client->id,
                'client_type' => get_class($client),
                'group_id' => $request->group_id,
                'taggable_id' => $request->taggable_id,
                'taggable_type' => 'App\\Models\\' . Str::ucfirst($request->taggable_type),
                'address' => $request->address,
                'email' => $request->email,
                'phone_number' => $request->phone_number,
            ]);
            //send notification
            if ($user)
                $client->notify(new TagNotification($this->notificationData($user, 'text', 'title')));
        }
        $tag['raed_at'] = Tag::where('group_id', $request->group_id)
            ->where('client_id', $client->id)->
            where('client_type', get_class($client))->
            where('read_at', null)->
            first()->read_at;

        return ($tag) ? $this->onSuccess($tag) : $this->onFaile('operation failed');
    }

    public function index($clientRole)
    {
        $this->read($clientRole);
        $client = auth($clientRole)->user();
//return get_class($client);
        $tag = Tag::query()->with('client.job_title')->where('taggable_id', $client->id)->where('taggable_type', get_class($client))->get();
        return ($tag) ? $this->onSuccess(ListTagResource::collection($tag)) : $this->onFaile('operation failed');
    }

    public function read($clientRole): void
    {
        $clientId = auth($clientRole)->user()->id;
        $clientType = 'App\\Models\\' . Str::ucfirst($clientRole);
        $tags = Tag::where('taggable_type', $clientType)->where('taggable_id', $clientId)->pluck('id');
//        return $user;
        $tag = Tag::whereIn('id', $tags)->update([
            'read_at' => now(),
        ]);
//        return $tag;
//       $tag
    }
    public function existsRead($clientRole){
        $clientId = auth($clientRole)->user()->id;
        $clientType = 'App\\Models\\' . Str::ucfirst($clientRole);
        $tags = Tag::where('taggable_type', $clientType)->where('taggable_id', $clientId)->where('read_at',null)->get();
//        return $tags;
        $read=Tag::where('taggable_type', $clientType)->where('taggable_id', $clientId)->where('read_at',null)->exists();
        return ($read)?$this->onSuccess(null):$this->onFaile(null);
    }


}
