<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class ParticipantsProject extends Model
{
    use HasFactory;
    protected $guarded=['id'];
    protected $table='participants_project';
    const CREATORE_ROLE='creatore';
    const GENERAL_CONTRACTOR_ROLE='general_contractor';
    const OWNER_ROLE='owner';
    protected $casts = [
        'start_date' => 'datetime',
        'end_date' => 'datetime',
    ];

    public function participantsProject()
    {
        return $this->morphTo('participantsProject','participants_project_type','participants_project_id');
    }
    public function industry(){
        return $this->hasOne(JobTitle::class,'id','job_title_id');
    }
    public function comment(){
        return $this->hasMany(Comment::class,'project_id','project_id');
    }

}
