<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Report extends Model
{
    use \Staudenmeir\EloquentEagerLimit\HasEagerLimit;
    use HasFactory;

    protected $table = 'reports';
    protected $guarded = [
        'id'
    ];

    public function images()
    {
        return $this->morphMany(Image::class, 'imageable');
    }

    public function fourImages()
    {
        return $this->morphMany(Image::class, 'imageable');
    }

    public function reportable()
    {
        return $this->morphTo();
    }
}
