<?php

namespace App\Repositories\Role;

use App\Models\Address;
use App\Models\Company;
use App\Models\User;
use JasonGuru\LaravelMakeRepository\Repository\BaseRepository;

//use Your Model

/**
 * Class AuthenticationRepository.
 */
class AuthenticationRepository extends BaseRepository
{
    public $request;

    /**
     * @return string
     *  Return the model
     */
    public function model()
    {
        return User::class;
    }


    public function register($request, $referralCode, $type, $familiarMethod)
    {
//        if (isset($request['phone_number']))
            $phone=isset($request['phone_number'])?$request['phone_number']:null;
        return $type::create([
            'password' => bcrypt($request['password']),
            'email' => $request['email'],
            'last_name' => $request['last_name'],
            'name' => $request['name'],
            'phone_number' => $phone,
            'referral_code' => $referralCode,
            //  'inviter_code' => $request['referral_code'],
            'familiar_method' => $familiarMethod,
            'status'=>'pending'
//                (isset($request['name'])&& isset($request['last_name'])&&(isset($phone))&&(isset($phone)))?'confirmed':'pending'
        ]);
    }

    public function registerComany($request, $referralCode, $type, $familiarMethod)
    {
        $client = $type::create([
            'password' => bcrypt($request['password']),
            'email' => $request['email'],
            'name' => $request['name'],
            'phone_number' => $request['phone_number'],
            'image' => $request['image'],
            'job_title_id' => $request['job_title_id'],
            'referral_code' => $referralCode,
            'status'=>(isset($request['name'])&& isset($request['country'])&& isset($request['main_text'])&&isset($request['secondary_text'])&& isset($request['state'])&& isset($request['zip_code'])&& isset($request['phone_number'])&&(isset($request['job_title_id'])))?'confirmed':'pending'
        ]);
        $address = ['country' => ($request['country'])??null,
            'main_text' => ($request['main_text'])??null,
            'secondary_text' => ($request['secondary_text'])??null,
            'state' => ($request['state'])??null, 'city' => ($request['city'])??null, 'zip_code' => ($request['zip_code'])??null
        ];
        $client->address()->create($address);
        return $client;
    }

    public function updateCompany($request, $id, $image)
    {
        return Company::where('id', $id)->update([
            'email' => $request['email'],
            'phone_number' => $request['phone_number'],
            'name' => $request['name'],
            'industry' => $request['industry'],
            'about_us' => $request['about_us']
        ]);
    }

    public function updateUser($request, $id, $jobTitleId, $image)
    {
        return User::where('id', $id)->update([
            'name' => $request['first_name'],
            'last_name' => $request['last_name'],
            'email' => $request['email'],
            'phone_number' => $request['phone_number'],
            'work_experience' => $request['work_experience'],
            'about_us' => $request['about_us'],
            'job_title_id' => $jobTitleId,
            'image' => $image
        ]);
    }
}
